InterpolatedAffineHazardRateCurve< Interpolator > Class Template Reference

`#include <ql/experimental/credit/interpolatedaffinehazardratecurve.hpp>`

Inheritance diagram for InterpolatedAffineHazardRateCurve< Interpolator >:
[legend]

## Public Member Functions

InterpolatedAffineHazardRateCurve (const std::vector< Date > &dates, const std::vector< Rate > &hazardRates, const DayCounter &dayCounter, const ext::shared_ptr< OneFactorAffineModel > &model, const Calendar &cal=Calendar(), const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >(), const Interpolator &interpolator=Interpolator())

| InterpolatedAffineHazardRateCurve (const std::vector< Date > &dates, const std::vector< Rate > &hazardRates, const DayCounter &dayCounter, const ext::shared_ptr< OneFactorAffineModel > &model, const Calendar &calendar, const Interpolator &interpolator)
| InterpolatedAffineHazardRateCurve (const std::vector< Date > &dates, const std::vector< Rate > &hazardRates, const DayCounter &dayCounter, const ext::shared_ptr< OneFactorAffineModel > &model, const Interpolator &interpolator)
TermStructure interface
Date | maxDate () const
| the latest date for which the curve can return values
Public Member Functions inherited from OneFactorAffineSurvivalStructure
| OneFactorAffineSurvivalStructure (const ext::shared_ptr< OneFactorAffineModel > &model, const DayCounter &dayCounter=DayCounter(), const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >())
| OneFactorAffineSurvivalStructure (const ext::shared_ptr< OneFactorAffineModel > &model, const Date &referenceDate, const Calendar &cal=Calendar(), const DayCounter &dayCounter=DayCounter(), const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >())
| OneFactorAffineSurvivalStructure (const ext::shared_ptr< OneFactorAffineModel > &model, Natural settlementDays, const Calendar &calendar, const DayCounter &dayCounter=DayCounter(), const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >())
Date | maxDate () const
| the latest date for which the curve can return values
Probability | conditionalSurvivalProbability (const Date &dFwd, const Date &dTgt, Real yVal, bool extrapolate=false) const
Probability | conditionalSurvivalProbability (Time tFwd, Time tgt, Real yVal, bool extrapolate=false) const
Rate | hazardRate (Time t, bool extrapolate=false) const
Rate | hazardRate (const Date &d, bool extrapolate=false) const
Rate | hazardRate (Time t, bool extrapolate=false) const
Public Member Functions inherited from HazardRateStructure
| HazardRateStructure (const DayCounter &dayCounter=DayCounter(), const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >())
| HazardRateStructure (const Date &referenceDate, const Calendar &cal=Calendar(), const DayCounter &dayCounter=DayCounter(), const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >())
| HazardRateStructure (Natural settlementDays, const Calendar &cal, const DayCounter &dayCounter=DayCounter(), const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >())
Public Member Functions inherited from DefaultProbabilityTermStructure
| DefaultProbabilityTermStructure (const DayCounter &dc=DayCounter(), const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >())
| DefaultProbabilityTermStructure (const Date &referenceDate, const Calendar &cal=Calendar(), const DayCounter &dc=DayCounter(), const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >())
| DefaultProbabilityTermStructure (Natural settlementDays, const Calendar &cal, const DayCounter &dc=DayCounter(), const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >())
Probability | survivalProbability (const Date &d, bool extrapolate=false) const
Probability | survivalProbability (Time t, bool extrapolate=false) const
Probability | defaultProbability (const Date &d, bool extrapolate=false) const
Probability | defaultProbability (Time t, bool extrapolate=false) const
Probability | defaultProbability (const Date &, const Date &, bool extrapolate=false) const
| probability of default between two given dates
Probability | defaultProbability (Time, Time, bool extrapo=false) const
| probability of default between two given times
Real | defaultDensity (const Date &d, bool extrapolate=false) const
Real | defaultDensity (Time t, bool extrapolate=false) const
Rate | hazardRate (const Date &d, bool extrapolate=false) const
Rate | hazardRate (Time t, bool extrapolate=false) const
const std::vector< Date > & | jumpDates () const
const std::vector< Time > & | jumpTimes () const
void | update ()
Public Member Functions inherited from TermStructure
| TermStructure (const DayCounter &dc=DayCounter())
| default constructor More...
| TermStructure (const Date &referenceDate, const Calendar &calendar=Calendar(), const DayCounter &dc=DayCounter())
| initialize with a fixed reference date
| TermStructure (Natural settlementDays, const Calendar &, const DayCounter &dc=DayCounter())
| calculate the reference date based on the global evaluation date
virtual | ~TermStructure ()
virtual DayCounter | dayCounter () const
| the day counter used for date/time conversion
Time | timeFromReference (const Date &date) const
| date/time conversion
virtual Time | maxTime () const
| the latest time for which the curve can return values
virtual const Date & | referenceDate () const
| the date at which discount = 1.0 and/or variance = 0.0
virtual Calendar | calendar () const
| the calendar used for reference and/or option date calculation
virtual Natural | settlementDays () const
| the settlementDays used for reference date calculation
Public Member Functions inherited from Observer
| Observer (const Observer &)
Observer & | operator= (const Observer &)
std::pair< iterator, bool > | registerWith (const ext::shared_ptr< Observable > &)
void | registerWithObservables (const ext::shared_ptr< Observer > &)
Size | unregisterWith (const ext::shared_ptr< Observable > &)
void | unregisterWithAll ()
virtual void | deepUpdate ()
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()
Public Member Functions inherited from Extrapolator
void | enableExtrapolation (bool b=true)
| enable extrapolation in subsequent calls
void | disableExtrapolation (bool b=true)
| disable extrapolation in subsequent calls
bool | allowsExtrapolation () const
| tells whether extrapolation is enabled

## other inspectors

const std::vector< Time > & | times () const
const std::vector< Date > & | dates () const
const std::vector< Real > & | data () const
const std::vector< Rate > & | hazardRates () const
std::vector< std::pair< Date, Real > > | nodes () const
| InterpolatedAffineHazardRateCurve (const DayCounter &, const ext::shared_ptr< OneFactorAffineModel > &model, const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >(), const Interpolator &interpolator=Interpolator())
| InterpolatedAffineHazardRateCurve (const Date &referenceDate, const DayCounter &, const ext::shared_ptr< OneFactorAffineModel > &model, const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >(), const Interpolator &interpolator=Interpolator())
| InterpolatedAffineHazardRateCurve (Natural settlementDays, const Calendar &, const DayCounter &, const ext::shared_ptr< OneFactorAffineModel > &model, const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >(), const Interpolator &interpolator=Interpolator())

## DefaultProbabilityTermStructure implementation

std::vector< Date > | dates_
Rate | hazardRate (const Date &d, bool extrapolate=false) const
Rate | hazardRate (Time t, bool extrapolate=false) const
Real | hazardRateImpl (Time) const
| Returns the deterministic hazard rate component.
Probability | survivalProbabilityImpl (Time) const
| survival probability calculation
Probability | conditionalSurvivalProbabilityImpl (Time tFwd, Time tTarget, Real yVal) const

## Additional Inherited Members

Public Types inherited from Observer
typedef boost::unordered_set< ext::shared_ptr< Observable > > | set_type
typedef set_type::iterator | iterator
Protected Member Functions inherited from OneFactorAffineSurvivalStructure
Probability | survivalProbabilityImpl (Time) const
| survival probability calculation
Real | defaultDensityImpl (Time) const
| default density calculation
Real | hazardRateImpl (Time t) const
| hazard rate calculation
Protected Member Functions inherited from HazardRateStructure
Probability | survivalProbabilityImpl (Time) const
Real | defaultDensityImpl (Time) const
| default density calculation
Protected Member Functions inherited from DefaultProbabilityTermStructure
Protected Member Functions inherited from TermStructure
void | checkRange (const Date &d, bool extrapolate) const
| date-range check
void | checkRange (Time t, bool extrapolate) const
| time-range check
Protected Member Functions inherited from InterpolatedCurve< Interpolator >
| InterpolatedCurve (const std::vector< Time > &times, const std::vector< Real > &data, const Interpolator &i=Interpolator())
| InterpolatedCurve (const std::vector< Time > &times, const Interpolator &i=Interpolator())
| InterpolatedCurve (Size n, const Interpolator &i=Interpolator())
| InterpolatedCurve (const Interpolator &i=Interpolator())
| InterpolatedCurve (const InterpolatedCurve &c)
InterpolatedCurve & | operator= (const InterpolatedCurve &c)
void | setupInterpolation ()
Protected Attributes inherited from OneFactorAffineSurvivalStructure
ext::shared_ptr< OneFactorAffineModel > | model_
Protected Attributes inherited from TermStructure
bool | moving_
bool | updated_
Calendar | calendar_
Protected Attributes inherited from InterpolatedCurve< Interpolator >
std::vector< Time > | times_
std::vector< Real > | data_
Interpolation | interpolation_
Interpolator | interpolator_
Date | maxDate_

## Detailed Description

### template<class Interpolator>
class QuantLib::InterpolatedAffineHazardRateCurve< Interpolator >

DefaultProbabilityTermStructure based on interpolation of a deterministic hazard rate component plus a stochastic one factor rate.

## Member Function Documentation

## conditionalSurvivalProbabilityImpl()

Probability conditionalSurvivalProbabilityImpl | ( | Time | tFwd,
|  | Time | tTarget,
|  | Real | yVal
| ) |  | const

protected virtual

Probability of default conditional to the realization of a given value of the stochastic part of the hazard rate at a prior time (and thus to survival at that time). \( P_{surv}(\tau>tTarget|F_{tFwd}) \)

Reimplemented from OneFactorAffineSurvivalStructure.